// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.Any;

public interface Any {	

	// comparing
	public boolean isEqual(Any anAny);
	public boolean notEqual(Any anAny);
	public boolean isIdentical(Any anAny);
	public boolean notIdentical(Any anAny);

	// copying 
	public Any shallowCopy();
	public Any deepCopy();
	public Any deepCopy(AnyContext anAnyContext);	// copy using different context
	
	// testing
	public boolean isObjectType();
	public boolean isValueType();
	public boolean isSimple();

	// casting
	public AnyArray asAnyArray();
	public AnyBoolean asAnyBoolean();
	public AnyDictionary asAnyDictionary();
	public AnyDouble asAnyDouble();
	public AnyFrame asAnyFrame();
	public AnyFrameDescriptor asAnyFrameDescriptor();
	public AnyInteger asAnyInteger();
	public AnySlotDescriptor asAnySlotDescriptor();
	public AnyString asAnyString();
	
	// accessing value
	public boolean asBoolean();
	public double asDouble();
	public int asInteger();
	public String asString();
	
	// printing
	public void print();							// pretty to System.out
	public String printOnString(boolean fast);
	
	// misc
	public void addAllTo(AnyArray anAnyArray);
	
}
