// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.Any;

public interface AnyArray extends Any {

	// accessing
	public int size();
	
	// accessing elements
	public Any at(int pos);
	
	// manipulating elements
	public int append(Any newElement);
	public void appendArray(AnyArray newElements);
	public Any atPut(int pos, Any newElement);	// expand if required
	public void insert(int pos, Any newElement);
	public Any remove(int pos);
	public void remove(Any element);  // removes all identical entries
	public void removeAll();
	
	// finding elements (test for equality)
	public AnyArray findAll(Any element);
	public AnyArray findAllWithSlot(AnyString key, Any anAny); 	// find frame or dictionary whose 	
	public AnyArray findAllWithSlot(String key, Any anAny);		// value at key is equals anAny
	public Any findFirst(Any element);
	public int findFirstPosition(Any element);
	public Any findFirstWithSlot(AnyString key, Any a);
	public Any findFirstWithSlot(String key, Any a);
	
	// misc
	public void expand(int newSize);
	public void sort();
	public void sort(AnyString key); // use key as sort criteria
	public void sort(String key);	 // in AnyFrame or AnyDictionary

}
