// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.Any;

import java.io.FileNotFoundException;
import java.io.IOException;

public interface AnySoup extends AnyContext {

	// accessing
	public IndexManager getIndexManager();
	public int getNextId();
	public AnyArray getData();	
	public AnyArray getAll();
	
	// setting
	public void setQueryProcessor(QueryProcessor aQueryProcessor);
	public void setData(AnyArray newData);

	// frame management
	public void add(AnyFrame anAnyFrame);	
	public void remove(AnyFrame aFrame);
	
	// IO
	public void store(AnyString fileName)
		throws IOException, FileNotFoundException;
	public void store(String fileName)
		throws IOException, FileNotFoundException;
	public void load(AnyString fileName)
		throws IOException, FileNotFoundException;
	public void load(String fileName)
		throws IOException, FileNotFoundException;
	public void storeMetaInformation(AnyString fileName)
		throws IOException, FileNotFoundException;
	public void storeMetaInformation(String fileName)
		throws IOException, FileNotFoundException;
	public void loadMetaInformation(AnyString fileName)
		throws IOException, FileNotFoundException;
	public void loadMetaInformation(String fileName)
		throws IOException, FileNotFoundException;

	// locking
	public boolean lock();
	public boolean unlock(boolean doCommit);
	public boolean isLocked();
	public void setClientInformation(boolean isLockerActive);

	// queries
	public AnyArray evaluateQuery(AnyString queryString);
	public AnyArray evaluateQuery(String queryString);	
	public void removeByQuery(AnyString queryString);
	public void removeByQuery(String queryString);	
	
	// printing
	public void print();   // pretty to System.out
	
}
