// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.Any;
import Geo.Framework.Any.AnyDouble;



public class AnyDoubleImpl extends AnyImpl implements AnyDouble {

	// instance variables
	
	protected double value;


	// constructors
	
	protected AnyDoubleImpl(double d) {
		value = d;
	}
	
	
	// accessing value
	
	public double asDouble() {
		return value;
	}
	
		
	// comparing

	public boolean isEqual(double d) {
		return value == d;
	}
	
	public boolean notEqual(double d) {
		return !isEqual(d);
	}
	
	public boolean isEqual(Any anAny) {
		return anAny != null 
			&& anAny instanceof AnyDouble 
			&& anAny.asDouble() == value;
	}	
	
	public int hashCode() {
		return String.valueOf(value).hashCode();
	}


	// testing
	
	public boolean isValueType() {
		return true;
	}

	
	// printing
	
	public String toString() {
		return String.valueOf(value);
	}
	
}
