// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.*;



public class AnySymbolTableImpl implements AnySymbolTable {

	// instance variables
	
	protected AnyDictionary symbols;


	// constructors
	
	public AnySymbolTableImpl() {
		symbols = new AnyDictionaryImpl();
	}
	
	
	// accessing

	public int size() {
		return symbols.size();
	}	
	
	public AnyArray all() {
		return symbols.values();
	}
	
	
	// frame descriptor management
	
	public AnyFrameDescriptor at(AnyString key) {
		if ( !symbols.hasSlot(key) )
			return null;
		else
			return symbols.slotAt(key).asAnyFrameDescriptor();
	}
	
	public void insert(AnyFrameDescriptor descriptor) {  
		symbols.setSlot(descriptor.getName(), descriptor); 
	}
	
	public void insertAll(AnyArray descriptors) {	
		for (int i=0, s=descriptors.size(); i<s; i++) 
			insert(descriptors.at(i).asAnyFrameDescriptor());	
	}
	
	// printing/reading
	
	public String printOnString(boolean fast) {
		return symbols.printOnString(fast);
	}
	
	public void readFromString(String in, AnyContext context) {
		symbols = AnyImpl.readFromString(in, context).asAnyDictionary();
	}

}
