// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import java.io.*;
import Geo.Framework.Any.IOManager;
import Geo.Framework.Any.AnyString;
import Geo.Framework.Any.AnySoup;



public class FileIOManagerImpl implements IOManager {

	// instance variables
	
	protected int nextId;
	protected AnySoup soup;


	// constructors
	
	public FileIOManagerImpl() {
		nextId = 0;
	}
	
	
	// accessing

	public AnySoup getSoup() {
		return soup;
	}
		
	public int getNextId() {
		return nextId++;
	}


	// setting
	
	public void setSoup(AnySoup soup) {
		this.soup = soup;
	}
	
	
	// IO
	
	public void store(AnyString fileName) throws IOException {
		String outputString = getSoup().getData().printOnString(false);
		FileWriter writer = new FileWriter(fileName.toString());
		writer.write(outputString);	
		writer.close();
	}
	
	public void load(AnyString fileName) throws FileNotFoundException, IOException {
		String inputString = readFileToString(fileName);
		getSoup().setData(AnyReaderDefImpl.read(inputString, getSoup()).asAnyArray());
	}
	
	public void storeMetaInformation(AnyString fileName) throws IOException {
		String outputString = getSoup().getSymbolTable().printOnString(true);
		FileWriter writer = new FileWriter(fileName.toString());
		writer.write(outputString);
		writer.close();
	}
	public void loadMetaInformation(AnyString fileName) throws FileNotFoundException, IOException {
		String inputString = readFileToString(fileName);
		getSoup().getSymbolTable().readFromString(inputString, getSoup());
	}
	
	
	// private 
	
	private String readFileToString(AnyString fileName) throws FileNotFoundException, IOException {
		File file = new File(fileName.toString());
		FileReader reader = new FileReader(file);
		char characterBuffer[] = new char[(int) file.length()];
		reader.read(characterBuffer, 0, (int) file.length());
		reader.close();
		return new String(characterBuffer);
	}

}
